#!/usr/bin/env python

#This file is part of videorg.

#videorg is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.

#videorg is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with videorg.  If not, see <http://www.gnu.org/licenses/>.

import re
import os

import data_structures as ds


RedundantTags = ['divx', 'maxspeed', 'torentz', 'www','3xforum ro', 'keltz', 'dvdscr', 'axxo', 'xvid', 'dvdrip', 'ac3', 'MVGroup', 'hDTV', 'fxm', 'flemish', 'tdf', 'subs', 'fxg', 'noneya', 'dino']
Braces = ['[',']', '(', ')']


class Cl_Movie:
	def __init__(self, movie):
                self.strmovie = movie

        def __str__(self):
            return self.strmovie

	def get_clean_movie(self):
		return self.strmovie

	def clean(self):
		# May be overwritten.
		pass

	""" This function replaces all fake white space in the filename """
	def cl_fake_white_space(self):
		FakeSpace = ['.', '_', '-']
		for x in FakeSpace:
                        if x in self.strmovie: 
			    self.strmovie = self.strmovie.replace(x, ' ')

	def cl_white_space(self):
		self.strmovie.rstrip()
		self.strmovie.lstrip()

class Cl_MovieSplit(Cl_Movie):
    def __init__(self, movie):
        Cl_Movie.__init__(self, movie)
        self.cl_fake_white_space()
        self.clean()

    def clean(self):
        regexp = re.compile('\d{4}')
        self.strmovie = regexp.split(self.strmovie)[0]
    


class Cl_MovieTags(Cl_Movie):
	def __init__(self, movie):
            Cl_Movie.__init__(self, movie)
            self.clean()


	def clean(self):
		self.strmovie = self.cl_dates()
		self.strmovie = self.cl_tags()

	def cl_dates(self):
		# Find out dates between [ and ]
		expr = re.compile('\(|\[+\d{4}\]|\)+')
		if expr.search(self.strmovie):
			self.strmovie = expr.sub('', self.strmovie)

		# Try to find out dates with surrounding characters
		expr = re.compile('19\d{2}|20\d{2}')
		if expr.search(self.strmovie):
			self.strmovie = expr.sub('', self.strmovie)


		return self.strmovie

	def cl_tags(self):
		self.strmovie = self.strmovie.lower()
	
		for tag in RedundantTags:
			if tag in self.strmovie:
				self.strmovie = self.strmovie.replace(tag, '')

		#remove things like [eng]
		expr = re.compile('\[+\D{3}\]+')
		if expr.search(self.strmovie):
			self.strmovie = expr.sub('', self.strmovie)

		#remove language information like eng 
		expr = re.compile(' eng |french')
		if expr.search(self.strmovie):
			self.strmovie = expr.sub('', self.strmovie)

                return self.strmovie        



