#!/usr/bin/env python

#This file is part of videorg.

#videorg is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.

#videorg is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with videorg.  If not, see <http://www.gnu.org/licenses/>.

import sys
import os
import re

import lib.term as term
import lib.movie_str as movie_str
import lib.data_structures as ds
import lib.http_req as hreq

def search_movie(file):
    movie = ds.Movie(file) 
    cl_movie = movie_str.Cl_MovieSplit(movie.get_filename())


    if Confirm("{6}Videorg suggests {0}{1}{2} te be renamed to {3}{4}{5} (y/n): ".format(term.bcolors.BLUE  ,file, term.bcolors.END, term.bcolors.GREEN, cl_movie, term.bcolors.END, term.bcolors.END)):
        movie.rename(cl_movie)
        return True

    print "Search for alternative"
    res = hreq.IMDB(cl_movie.get_clean_movie())

    if res and Confirm("{6}Videorg suggests {0}{1}{2} te be renamed to {3}{4}{5} (y/n): ".format(term.bcolors.BLUE  ,file, term.bcolors.END, term.bcolors.GREEN, res[0], term.bcolors.END, term.bcolors.END)):
        pass
    else:
        print "Searching for alternative"
        movie = ds.Movie(file) 
        cl_movie = movie_str.Cl_MovieSplit(movie.get_filename())
        res = hreq.IMDB(cl_movie.get_clean_movie())
        if res and Confirm("{6}Videorg suggests {0}{1}{2} te be renamed to {3}{4}{5} (y/n): ".format(term.bcolors.BLUE  ,file, term.bcolors.END, term.bcolors.GREEN, res[0], term.bcolors.END, term.bcolors.END)):
            pass
        else:
            print "No suitable name has been found."
            print 

def Confirm(qstr):
    input = raw_input(qstr)
    if input == 'y':
        return True
    else:
        return False


if __name__ == "__main__":
    args = sys.argv[1:]
    if not len(args) > 0:
        print "TODO: ERROR"
        sys.exit()

    if os.path.isdir(args[0]) and os.path.exists(args[0]):
        for file in os.listdir(args[0]):
            search_movie(file)

    elif os.path.isfile(args[0]):
        search_movie(args[0])


                
            
